SketchUp C API

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Related Functions
SUPolyline3dRef Struct Reference

A polyline3d object. These are curve-like entities that do not generate inference snaps or affect geometry in any way. More...

`#include <SketchUpAPI/model/polyline3d.h>`

Inherits SUEntityRef.

## Related Functions
(Note that these are not member functions.)
SUEntityRef | SUPolyline3dToEntity (SUPolyline3dRef line)
| Converts from an SUPolyline3dRef to an SUEntityRef. This is essentially an upcast operation. More...
SUPolyline3dRef | SUPolyline3dFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUPolyline3dRef. This is essentially a downcast operation so the given entity must be convertible to an SUPolyline3dRef. More...
SUDrawingElementRef | SUPolyline3dToDrawingElement (SUPolyline3dRef line)
| Converts from an SUPolyline3dRef to an SUDrawingElementRef. This is essentially an upcast operation. More...
SUPolyline3dRef | SUPolyline3dFromDrawingElement (SUDrawingElementRef drawing_elem)
| Converts from an SUDrawingElementRef to an SUPolyline3dRef. This is essentially a downcast operation so the given element must be convertible to an SUPolyline3dRef. More...
enum SUResult | SUPolyline3dCreate (SUPolyline3dRef *polyline)
| Creates a new polyline3d object. The polyline3d object must be subsequently deallocated with SUPolyline3dRelease() unless it is associated with a parent object. More...
enum SUResult | SUPolyline3dRelease (SUPolyline3dRef *polyline)
| Releases a new polyline3d object. The polyline3d object must not be associated with a parent object. More...
enum SUResult | SUPolyline3dAddPoints (SUPolyline3dRef polyline, size_t num_points, struct SUPoint3D points[])
| Adds points to a polyline3d object. More...
enum SUResult | SUPolyline3dGetNumPoints (SUPolyline3dRef line, size_t *count)
| Retrieves the number of points contained by a polyline3d. More...
enum SUResult | SUPolyline3dGetPoints (SUPolyline3dRef line, size_t len, struct SUPoint3D points[], size_t *count)
| Retrieves the points in the polyline3d object. More...
Related Functions inherited from SUEntityRef
enum SURefType | SUEntityGetType (SUEntityRef entity)
| Returns the concrete type of the given entity. More...
enum SUResult | SUEntityGetID (SUEntityRef entity, int32_t *entity_id)
| Retrieves the id of the entity. More...
enum SUResult | SUEntityGetPersistentID (SUEntityRef entity, int64_t *entity_pid)
| Retrieves the persistent id of the entity. More...
enum SUResult | SUEntityGetNumAttributeDictionaries (SUEntityRef entity, size_t *count)
| Retrieves the number of attribute dictionaries of an entity. More...
enum SUResult | SUEntityGetAttributeDictionaries (SUEntityRef entity, size_t len, SUAttributeDictionaryRef dictionaries[], size_t *count)
| Retrieves the attribute dictionaries of an entity. More...
enum SUResult | SUEntityAddAttributeDictionary (SUEntityRef entity, SUAttributeDictionaryRef dictionary)
| Adds the attribute dictionary to an entity. The given dictionary object must not belong to another entity. In other words, each dictionary should be added to one entity only. More...
enum SUResult | SUEntityGetAttributeDictionary (SUEntityRef entity, const char *name, SUAttributeDictionaryRef *dictionary)
| Retrieves the attribute dictionary of an entity that has the given name. More...
enum SUResult | SUEntityGetModel (SUEntityRef entity, SUModelRef *model)
| Retrieves the model object associated with the entity. More...
enum SUResult | SUEntityGetParentEntities (SUEntityRef entity, SUEntitiesRef *entities)
| Retrieves the entities object which contains the entity. More...

## Detailed Description

A polyline3d object. These are curve-like entities that do not generate inference snaps or affect geometry in any way.

## Friends And Related Function Documentation

enum SUResult SUPolyline3dAddPoints | ( | SUPolyline3dRef | polyline,
|  | size_t | num_points,
|  | struct SUPoint3D | points[]
| ) |  |
| related

Adds points to a polyline3d object.

Parameters

  [in] | polyline | The polyline3d object.
  [in] | num_points | Number of points being added.
  [in] | points | Array of points to add.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if polyline is not a valid object
  - SU_ERROR_NULL_POINTER_INPUT if points is NULL

enum SUResult SUPolyline3dCreate | ( | SUPolyline3dRef * | polyline | ) |
| related

Creates a new polyline3d object. The polyline3d object must be subsequently deallocated with SUPolyline3dRelease() unless it is associated with a parent object.

Parameters

  [out] | polyline | The polyline3d object.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_NULL_POINTER_OUTPUT if polyline is NULL

SUPolyline3dRef SUPolyline3dFromDrawingElement | ( | SUDrawingElementRef | drawing_elem | ) |
| related

Converts from an SUDrawingElementRef to an SUPolyline3dRef. This is essentially a downcast operation so the given element must be convertible to an SUPolyline3dRef.

Parameters

  [in] | drawing_elem | The drawing element object.

Returns
  - The converted SUPolyline3dRef if the downcast operation succeeds. If not, the returned reference will be invalid.

SUPolyline3dRef SUPolyline3dFromEntity | ( | SUEntityRef | entity | ) |
| related

Converts from an SUEntityRef to an SUPolyline3dRef. This is essentially a downcast operation so the given entity must be convertible to an SUPolyline3dRef.

Parameters

  [in] | entity | The given entity reference.

Returns
  - The converted SUPolyline3dRef if the downcast operation succeeds. If not, the returned reference will be invalid.

enum SUResult SUPolyline3dGetNumPoints | ( | SUPolyline3dRef | line,
|  | size_t * | count
| ) |  |
| related

Retrieves the number of points contained by a polyline3d.

Parameters

  [in] | line | The polyline3d object.
  [out] | count | The number of points available.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if line is an invalid object
  - SU_ERROR_NULL_POINTER_OUTPUT if count is NULL

enum SUResult SUPolyline3dGetPoints | ( | SUPolyline3dRef | line,
|  | size_t | len,
|  | struct SUPoint3D | points[],
|  | size_t * | count
| ) |  |
| related

Retrieves the points in the polyline3d object.

Parameters

  [in] | line | The polyline3d object.
  [in] | len | The maximum number of points to retrieve.
  [out] | points | The points retrieved.
  [out] | count | The number of points retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if line is an invalid object
  - SU_ERROR_NULL_POINTER_OUTPUT if points or count is NULL

enum SUResult SUPolyline3dRelease | ( | SUPolyline3dRef * | polyline | ) |
| related

Releases a new polyline3d object. The polyline3d object must not be associated with a parent object.

Parameters

  [in] | polyline | The polyline3d object.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if polyline does not reference a valid object
  - SU_ERROR_NULL_POINTER_INPUT if polyline is NULL

SUDrawingElementRef SUPolyline3dToDrawingElement | ( | SUPolyline3dRef | line | ) |
| related

Converts from an SUPolyline3dRef to an SUDrawingElementRef. This is essentially an upcast operation.

Parameters

  [in] | line | The polyline3d object.

Returns
  - The converted SUEntityRef if line is a valid object. If not, the returned reference will be invalid.

SUEntityRef SUPolyline3dToEntity | ( | SUPolyline3dRef | line | ) |
| related

Converts from an SUPolyline3dRef to an SUEntityRef. This is essentially an upcast operation.

Parameters

  [in] | line | The polyline3d object.

Returns
  - The converted SUEntityRef if line is a valid object. If not, the returned reference will be invalid.

The documentation for this struct was generated from the following files:

- SketchUpAPI/model/defs.h
- SketchUpAPI/model/polyline3d.h